#!/usr/bin/perl
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
sysread (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}
if (!$data{EMail})
{
	&closedb;
	$errors.="Please enter your email<br>\n";
	open (F,"<$pwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage=~s/\@/\\\@/g;
	$htmlpage=~s/\~/\\\~/g;
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT username,password FROM pw_users WHERE email='$data{EMail}'");
while (($username,$password)=$sth->fetchrow)
{
	open (MAIL,"|$progmail");
	print MAIL "To: $data{EMail}\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Password request\n\n";
	print MAIL "Login: $username\nPassword: $password\n\n";
	print MAIL "\n.\n";
	close (MAIL);
	$ff=1;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($ff)
{
	&closedb;
	open (F,"<$pwpath/template/pass.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage=~s/\@/\\\@/g;
	$htmlpage=~s/\~/\\\~/g;
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&closedb;
$errors.="Your email is not exist in our database<br>\n";
open (F,"<$pwpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub closedb
{
$sth="";
$dbh="";
}
